VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5910
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   5910
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "List Duplicates"
      Height          =   495
      Left            =   2325
      TabIndex        =   1
      Top             =   2610
      Width           =   1215
   End
   Begin VB.ListBox List1 
      Height          =   2400
      Left            =   285
      TabIndex        =   0
      Top             =   165
      Width           =   5190
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Try this, it works fastest With a Sorted List, but Is still quick either way..

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
        (ByVal hwnd As Long, ByVal wMsg As Long, _
        ByVal wParam As Long, lParam As Any) As Long

Private Const LB_FINDSTRINGEXACT = &H1A2

Private Sub Command1_Click()
    Dim iIndex As Long
    Dim iMatch As Long
    Dim iCopies As Long
    Dim iHighest As Long
    Dim aCommon() As Long
    Dim sString As String
    Dim bSkip As Boolean

    For iIndex = 0 To List1.ListCount - 1
        iCopies = 0
        iMatch = -1
        bSkip = False
        'Skip this one if it's the same as the last Item Checked
        If iIndex Then
            bSkip = (List1.List(iIndex) = List1.List(iIndex - 1))
        End If

        'Skip this one if there's a previous instance of it in the List
        If Not bSkip Then
            bSkip = (SendMessage(List1.hwnd, LB_FINDSTRINGEXACT, -1, _
                    ByVal List1.List(iIndex)) < iIndex)
        End If
        'While there are other Instances in the List..
        While iMatch <> iIndex And Not bSkip
            'Increment the No of Copies Found of this Item
            iCopies = iCopies + 1
            'Find the next Copy..
            iMatch = SendMessage(List1.hwnd, LB_FINDSTRINGEXACT, IIf(iMatch < 0, iIndex, iMatch), ByVal List1.List(iIndex))
        Wend
        'If there were more than 1 Copies
        If iCopies > 1 And Not bSkip Then
            'If the No. of Copies is Greater or the Same as the Highest so far..
            If iCopies >= iHighest Then
                If iCopies > iHighest Then
                    'new Highest Copies
                    ReDim aCommon(0)
                Else
                    'Another Item with the same highest amount of Copies
                    ReDim Preserve aCommon(UBound(aCommon) + 1)
                End If
                'Store this Index
                aCommon(UBound(aCommon)) = iIndex
                'Remember the Highest No. of Copies
                iHighest = iCopies
            End If
        End If
    Next
    If iHighest Then
        'If Copies were Found..
        For iIndex = 0 To UBound(aCommon)
            sString = sString & ", " & List1.List(aCommon(iIndex))
        Next
        
        MsgBox "Most Repeated Item(s): " & vbCrLf & Mid$(sString, 3) & _
                vbCrLf & vbCrLf & "Repeated " & iHighest & " Times.", _
                vbInformation + vbOKOnly, "Repeats"
        Caption = "Most Repeated Item(s): " & Mid$(sString, 3) & _
                 " Repeated " & iHighest & " Times."
    Else
        'No Copies Found..
        MsgBox "No Items were Repeated", vbInformation + vbOKOnly, "No Repeats"
    End If
End Sub


'Aaron Young
'Analyst Programmer
'ajyoung@pressenter.com <mailto:ajyoung@pressenter.com>
'aarony@redwingsoftware.com <mailto:aarony@redwingsoftware.com>

Private Sub Form_Load()
    Dim s As Variant
    Dim i As Integer
    Dim iP As Integer
    
    s = Array("List item 1", "List Item 2", "List Item 3", "List Item 4", "List Item 5")
    
    For i = 1 To 5
        List1.AddItem s(0)
    Next
    For i = 1 To 15
        List1.AddItem s(1)
    Next
    For i = 1 To 25
        List1.AddItem s(2)
    Next
    For i = 1 To 35
        List1.AddItem s(3)
    Next
    For i = 1 To 15
        List1.AddItem s(4)
    Next
    
End Sub
